"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = UserlikeJoke;

var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));

var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _flatMap = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/flat-map"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _pipeable = require("fp-ts/lib/pipeable");

var A = _interopRequireWildcard(require("fp-ts/lib/Array"));

var O = _interopRequireWildcard(require("fp-ts/lib/Option"));

var _helperModuleImports = require("@babel/helper-module-imports");

const MODULE_NAME = "@userlike/joke";
const IMPORT_FN = "mock";
const GLOBAL_JEST = "jest";
const GLOBAL_JEST_FN = "mock";

function UserlikeJoke({
  types: t
}) {
  return {
    name: "@userlike/babel-plugin-joke",
    visitor: {
      Program(path) {
        var _context, _context2, _context3, _context4, _context5, _context6, _context7;

        const statements = path.node.body;
        const mockRefs = (0, _map.default)(_context = (0, _filter.default)(_context2 = (0, _filter.default)(_context3 = (0, _flatMap.default)(_context4 = (0, _filter.default)(_context5 = (0, _filter.default)(statements).call(statements, pred(t.isImportDeclaration))).call(_context5, s => s.source.value === MODULE_NAME)).call(_context4, s => s.specifiers)).call(_context3, pred(t.isImportSpecifier))).call(_context2, s => s.imported.name === IMPORT_FN)).call(_context, s => s.local.name);
        const mockRefPaths = (0, _flatMap.default)(_context6 = (0, _filter.default)(_context7 = (0, _map.default)(mockRefs).call(mockRefs, ref => path.scope.getBinding(ref))).call(_context7, ref => ref !== undefined)).call(_context6, ref => ref.referencePaths);
        (0, _forEach.default)(mockRefPaths).call(mockRefPaths, process(t, path));
      }

    }
  };
}

function process(t, path) {
  return mockPath => {
    var _context8, _context9, _context10;

    const callPath = mockPath.parentPath;
    const call = mockPath.parent;
    invariant(t.isCallExpression(call));
    const asyncImport = call.arguments[0];
    invariant(t.isCallExpression(asyncImport));
    invariant(t.isImport(asyncImport.callee));
    invariant(asyncImport.arguments.length === 1);
    const moduleNameLiteral = asyncImport.arguments[0];
    invariant(t.isStringLiteral(moduleNameLiteral));
    const moduleName = moduleNameLiteral.value;
    const declaratorPath = callPath.parentPath;
    const declarator = declaratorPath.node;
    invariant(t.isVariableDeclarator(declarator));
    const objectPattern = declarator.id;
    invariant(t.isObjectPattern(objectPattern));
    const namedImports = (0, _map.default)(_context8 = objectPattern.properties).call(_context8, p => {
      invariant(!t.isRestElement(p));
      invariant(t.isIdentifier(p.key));
      invariant(t.isIdentifier(p.value));
      return [p.key.name, p.value.name];
    });
    const declarationPath = declaratorPath.parentPath;
    const declaration = declarationPath.node;
    invariant(t.isVariableDeclaration(declaration));
    const idx = (0, _findIndex.default)(_context9 = declaration.declarations).call(_context9, d => d === declarator);
    (0, _splice.default)(_context10 = declaration.declarations).call(_context10, idx, 1);

    if (declaration.declarations.length === 0) {
      declarationPath.remove();
    }

    (0, _forEach.default)(namedImports).call(namedImports, ([k, v]) => {
      const newName = (0, _helperModuleImports.addNamed)(path, k, moduleName, {
        nameHint: v
      });
      path.scope.rename(v, newName.name);
    });
    const insertionIO = (0, _pipeable.pipe)(path.get("body"), A.findLast(p => t.isImportDeclaration(p.node)), O.map(lastImportPath => () => lastImportPath.insertAfter(t.expressionStatement(t.callExpression(t.memberExpression(t.identifier(GLOBAL_JEST), t.identifier(GLOBAL_JEST_FN)), [t.stringLiteral(moduleName)])))), O.getOrElse(() => () => {}));
    insertionIO();
  };

  function throwErr() {
    throw new Error(`\`mock\` must be a call expression.
                e.g. \`mock(import("moduleName"))\`.
                Instead saw \`${path.getSource()}\`.
                `);
  }

  function invariant(condition) {
    if (condition) return;
    throwErr();
  }
}

function pred(predicate) {
  return predicate;
}